<template>
    <view class="container" style="paddingBottom:1rpx;">
      <u-navbar
			leftIconSize="40rpx"
			leftIconColor="#333333"
			title="股票账单"
		>
		</u-navbar>
      <view class="section">
        <view class="section-title">{{ title}}</view>
        <view class="form-view">
          <u--form labelPosition="left" :model="form" :rules="rules" ref="uForm" label-width="auto"
            :labelStyle="{ color: '#333333', fontSize: '30rpx' }">
            <u-form-item label="股票账户" prop="futureStocksName" required @click="handleFutureStocks">
              <u--input v-model="form.futureStocksName" disabled disabledColor="#ffffff" placeholder="请选择股票账户"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item>
            <u-form-item label="账单日" prop="billDate" required @click="selectDate()">
              <u--input v-model="form.billDate" disabled disabledColor="#ffffff" placeholder="请选择账单日" inputAlign="right" border="none"></u--input>
						<u-icon slot="right" name="arrow-right"></u-icon>
            </u-form-item>
            <u-form-item label="股票收益" prop="billAmount" required >
              <u--input v-model="form.billAmount"  placeholder="请填写股票收益"
                inputAlign="right" border="none"></u--input>
            </u-form-item>
            <u-form-item label="备注" prop="remark"  labelPosition="top">
              <u--textarea v-model="form.remark" placeholder="请填写备注" border="none" autoHeight inputAlign="right" count
                maxlength="20000" style="padding:18rpx 0;"></u--textarea>
            </u-form-item>
          </u--form>
          <view class="form-btn">
            <u-button type="primary" text="提交" @click="submit"></u-button>
          </view>
        </view>
      </view>
      <u-toast ref="uToast"></u-toast>
      <u-picker itemHeight="88" :show="showTeam" :columns="billStateList" keyName="dictLabel" @cancel="handleCancel"
        @confirm="handleConfirm"></u-picker>
        <u-datetime-picker
			:show="datePickShow"
			mode="date"
      ref="createTimeRef" 
			@cancel="datePickShow=false"
			@confirm="datePickConfirm"
			itemHeight="88"
		></u-datetime-picker>
    <u-picker itemHeight="88" :show="showFutureStocks" :columns="futureStocksBillList" keyName="nameCode" @cancel="handleFutureStocksCancel"
        @confirm="handleFutureStocksConfirm"></u-picker>
    </view>
  </template>
  
  <script setup>
import {getFutureStocksBill, addFutureStocksBill, updateFutureStocksBill } from '@/api/invest/futureStocksBill'
  import { listFutureStocks } from '@/api/invest/futureStocks'
  const { proxy } = getCurrentInstance()
  import dayjs from 'dayjs'
  import {onLoad,onReady} from "@dcloudio/uni-app";
    // 计算属性与监听属性是在vue中而非uniap中 需要注意！！！
import {reactive ,toRefs,ref,computed ,getCurrentInstance }from "vue";
const datePickShow = ref(false)
const showTeam = ref(false)
const showFutureStocks = ref(false)
const title = ref("股票账单")
const futureStocksBillList = ref([])
const billStateList = ref([])
const data = reactive({
  form: {
    id: null,
    name: null,
    billDate: null,
    futureStocksId: null,
    billDatePeriod: null,
    billAmount: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    delFlag: null,
    type: '2',
    remark: null,
    billYear: null,
    billMonth: null
  },
  queryFutureStocksListParams: {
    pageNum: 1,
    type: '2',
    pageSize: 1000
  },
  rules: {
           futureStocksName: [{ type: 'string', required: true, message: '股票账户不能为空', trigger: ['change', 'blur'] }],
          billDate: [{ type: 'string', required: true, message: '账单日不能为空', trigger: ['change', 'blur'] }],
          billAmount: [{ type: 'number', required: true, message: '股票收益不能为空', trigger: ['change', 'blur'] }],
  }
})
const { form, queryFutureStocksListParams, rules} = toRefs(data)

onLoad((option) => {
       form.value.id = option.id
       if(form.value.id!=null){
        title.value="股票账单-修改"
       }else{
        title.value="股票账单-新增"
       }
      getDict()
  })
  onReady(() => {
    form.value.billDate = dayjs(new Date().getTime()).format("YYYY-MM-DD")
  })
  function  getDict() {
    listFutureStocks(queryFutureStocksListParams.value).then((response) => {
        futureStocksBillList.value = [response.rows] 
      })
      if(form.value.id!=null){
        getFutureStocksBill(form.value.id).then(res => {
          form.value = res.data
          form.value.futureStocksName = res.data.futureStocksNameCode 
        })
      }
  }
  function dictStr(val, arr) {
      let str = ''
      arr.map(item => {
        if (item.dictValue === val) {
          str = item.dictLabel
        }
      })
      return str
    }

      function handleFutureStocks() {
        if (futureStocksBillList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '股票账户为空  ', type: 'warning'
          })
        } else {
          showFutureStocks.value = true
        }
     }
  function   handleFutureStocksConfirm(e) {
        form.value.futureStocksName = e.value[0].nameCode
        form.value.futureStocksId= e.value[0].id
        showFutureStocks.value = false
  }
 function handleFutureStocksCancel() {
       showFutureStocks.value = false
  }

      function  selectDate() {
				datePickShow.value = true
        proxy.$refs['createTimeRef'].innerValue = new Date().getTime()
			}
			function datePickConfirm(e) {
				form.value.createTime = dayjs(e.value).format("YYYY-MM-DD")
				datePickShow.value = false
			}
      function submit() {
        proxy.$refs['uForm'].validate().then(() => {
          if (form.value.id != null) {
            updateFutureStocksBill(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '修改成功', complete() {
                uni.navigateTo({ url: `/pages/work/bill/stocksBill/list` })
              }
            })
          })
          }else {
            addFutureStocksBill(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '新增成功', complete() {
                uni.navigateTo({ url: `/pages/work/bill/stocksBill/list` })
              }
            })
          })
          }
        })
      }
  </script>
  
  <style lang="scss" scoped>
  .section {
    margin: 24rpx;
    padding: 16rpx 24rpx;
    background-color: #fff;
    border-radius: 8rpx;
  
    .section-title {
      width: 360rpx;
      color: #333333;
      line-height: 44rpx;
      font-size: 30rpx;
      border-left: 6rpx solid #2681FF;
      padding-left: 26rpx;
    }
  
    .form-view {
      padding: 20rpx 0rpx 0 10rpx;
  
      .form-btn {
        padding-top: 20rpx;
      }
    }
  }
  </style>